//
//  OJSUtils.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/11/14.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import Foundation


func DLog(_ message: Any, function: String = #function, line: Int = #line, file: String = #file) -> Void {
    
    #if DEBUG
        let tempArray = file.components(separatedBy: "/")
        let fileName = tempArray.last!
        let string = "file: \(fileName) line: \(line) func: \(function) log:\(message)"
        ConsoleInfoString += "\n" + string + "\n"
        NSLog(string)// 用NSLog不用print是因为print默认不输出时间
        
    #endif
    
    
}

func OJSColor(r: Int, g: Int, b: Int, a: Float = 1.0) -> UIColor {
    return UIColor(red: CGFloat(r)/255.0, green: CGFloat(g)/255.0, blue: CGFloat(b)/255.0, alpha: CGFloat(a))
}

func OJSColor(hexRGBValue: Int) -> UIColor {
    let red = (hexRGBValue & 0xFF0000) >> 16
    let green = (hexRGBValue & 0xFF00) >> 8
    let blue = (hexRGBValue & 0xFF)
    return OJSColor(r: red, g: green, b: blue, a: 1.0)
}

func delay(_ delay: Double, closure: @escaping () -> Void) {
    DispatchQueue.main.asyncAfter(deadline: DispatchTime.now() + Double(Int64(delay * Double(NSEC_PER_SEC))) / Double(NSEC_PER_SEC), execute: closure)
}







extension UIColor {
    
    class func OJSColor(r: Int, g: Int, b: Int, a: Float) -> UIColor {
        return UIColor(red: CGFloat(r)/255.0, green: CGFloat(g)/255.0, blue: CGFloat(b)/255.0, alpha: CGFloat(a))
    }
    
    class func OJSColorFromHex(_ hexRGBValue: Int) -> UIColor {
        let red = (hexRGBValue & 0xFF0000) >> 16
        let green = (hexRGBValue & 0xFF00) >> 8
        let blue = (hexRGBValue & 0xFF)
        return OJSColor(r: red, g: green, b: blue, a: 1.0)
    }
}
