//
//  OJSViewController.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/11/14.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import UIKit

let kDefaultNumberOfTouchesRequired = 2

class OJSViewController: UIViewController {

    var ojs_isPushOrPopAnimating = false
    
    
}

// MARK: - Lifecycle
extension OJSViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        #if DEBUG
            
            let leftSwipeGesture = UISwipeGestureRecognizer(target: self, action: #selector(OJSViewController.handleLeftSwipeGesture(sender:)))
            leftSwipeGesture.direction = .left
            leftSwipeGesture.numberOfTouchesRequired = kDefaultNumberOfTouchesRequired
            self.view.addGestureRecognizer(leftSwipeGesture)
            
            let rightSwipeGesture = UISwipeGestureRecognizer(target: self, action: #selector(OJSViewController.handleRightSwipeGesture(sender:)))
            rightSwipeGesture.direction = .right
            rightSwipeGesture.numberOfTouchesRequired = kDefaultNumberOfTouchesRequired
            self.view.addGestureRecognizer(rightSwipeGesture)
            
        #endif
        
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        ojs_isPushOrPopAnimating = false
    }
    
    override func viewDidDisappear(_ animated: Bool) {
        super.viewDidDisappear(animated)
        ojs_isPushOrPopAnimating = false
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
}


// MARK: - PrivateMethod
private extension OJSViewController {
    
    
    @objc func handleLeftSwipeGesture(sender: UISwipeGestureRecognizer) -> Void {
        let consoleViewController = OJSConsoleViewController()
        self.present(consoleViewController, animated: true, completion: { () -> Void in
            
        })
    }
    
    @objc func handleRightSwipeGesture(sender: UISwipeGestureRecognizer) -> Void {
        
    }
}


